<template>
  <div class="SelectUser">
    <div class="header-middle">
      <div class="hint">
        <span v-for="(item, index) in slectList" :key="index"><span v-if="index" style="margin:0 4px;">/</span><span style="color:#3F8DF5" @click="girdNameClick(item, index)">{{item.girdName}}</span></span>
      </div>

      <div class="showTypes" v-if="!userList.length">
        <div v-if="treeList.length > 0">
          <div class="cards" v-for="(item, index) in treeList" :key="index" @click="itemClick(item)">
            <div class="imges">
              <span v-if="item.girdLevel == 2">
                <img src="./components/img/xzh.png" alt="" class="imgselect" v-if="item.isChecked" @click.stop="girdClick(item, index)" />
                <img src="./components/img/xz.png" alt="" class="imgselect" v-else @click.stop="girdClick(item, index)" />
              </span>
              <img src="./components/img/gird--select-icon.png" alt="" class="avatras" />
            </div>
            <div class="rightes">
              <div class="applicationNames">{{ item.girdName }}</div>
              <img src="./components/img/right-icon.png" alt="" class="imgs" />
            </div>
          </div>
        </div>

        <AiEmpty description="暂无数据" class="emptyWrap" v-else></AiEmpty>
      </div>

      <div class="showUsers" v-else>
        <div v-if="userList.length > 0">
          <div class="cards" v-for="(e, index) in userList" :key="index">
            <div class="imges">
              <img src="./components/img/xzh.png" alt="" class="imgselect" v-if="e.isChecked" @click="userClick(e, index)" />
              <img src="./components/img/xz.png" alt="" class="imgselect" v-else @click="userClick(e, index)" />

              <img src="./components/img/tx@2x.png" alt="" class="avatras" />
            </div>

            <div class="rights">
              <div class="applicationNames">{{ e.name }}</div>
              <div class="idNumbers">{{ e.phone }}</div>
            </div>
          </div>
        </div>

        <AiEmpty description="暂无数据" class="emptyWrap" v-else></AiEmpty>
      </div>
    </div>

    <div class="subBtn" @click="submit">
      <div>确定选择</div>
    </div>

  </div>
</template>

<script>
export default {
  name: 'SelectUser',
  data() {
    return {
      selectUser: {},
      allData: null,
      treeList: [],
      slectList: [],
      userList: [],
    }
  },
  onLoad() {
    this.getTree()
  },
  methods: {
    getTree() {
      this.slectList = []
      this.$http.post('/app/appgirdinfo/listAllByTop').then((res) => {
        if (res?.data) {
          this.allData = res.data
          this.treeInit()
        }
      })
    },

    treeInit() {
      if(this.allData[0].isLastLevel == 1) {
        this.userList = this.allData[0].girdMemberList
        this.userList.map((item) => {
          item.isChecked = false
        })
      }else {
        this.treeList = this.allData[0].girdList
      }
      var obj = {
        girdName: this.allData[0].girdName,
        id: this.allData[0].id,
        girdLevel: this.allData[0].girdLevel
      }
      this.slectList.push(obj)
    },

    itemClick(row) {
      console.log(row)
      var obj = {
        girdName: row.girdName,
        id: row.id,
        girdLevel: row.girdLevel
      }
      this.slectList.push(obj)
      this.searckGird(row)
    },

    searckGird(row) {
      if(row.girdLevel != 2) { //查网格
        this.$http.post(`/app/appgirdinfo/list?parentGirdId=${row.id}&size=999`).then((res) => {
          if (res?.data) {
            this.treeList = res.data.records
          }
        })
      }else { //查网格员
        this.$http.post(`/app/appgirdmemberinfo/listByGirdIdByThree?girdId=${row.id}`).then((res) => {
          if (res?.data) {
            this.userList = res.data
            this.userList.map((item) => {
              item.isChecked = false
            })
          }
        })
      }
    },

    girdNameClick(row, index) {
      this.userList = []
      if(!index) { //第一级别
        this.slectList = []
        this.treeInit()
      }else {
        var list = []
        this.slectList.map((item, i) => {
          if(i <= index) {
            list.push(item)
          }
        })
        this.slectList = list
        this.searckGird(row)
      }
    },
    

    girdClick(row, index) {
      if (this.treeList[index].isChecked) {//取消
        this.treeList[index].isChecked = false
        this.selectUser = {}
      } else {
        this.treeList.map((item) => {
          item.isChecked = false
        })
        this.treeList[index].isChecked = true
        this.selectUser = row
      }
      this.$forceUpdate()
    },

    userClick(row, index) {
      if (this.userList[index].isChecked) {//取消
        this.userList[index].isChecked = false
        this.selectUser = {}
      } else {
        this.userList.map((item) => {
          item.isChecked = false
        })
        this.userList[index].isChecked = true
        this.selectUser = row
      }
      this.$forceUpdate()
    },

    submit() {
      if (this.selectUser.id != null) {
        uni.$emit('goback', this.selectUser)
        uni.navigateBack()
      } else {
        return this.$u.toast('请选择网格或网格员')
      }
    },
  }
}
</script>

<style scoped lang="scss">
.SelectUser {
  height: 100%;
  background: #fff;
  .header-top {
    background: #fff;
    padding: 20px 32px;
  }

  .header-middle {
    padding-bottom: 140px;
    .hint {
      padding: 28px 20px 28px 32px;
      line-height: 56px;
      box-shadow: 0px 1px 0px 0px #e4e5e6;
      font-size: 30px;
      font-weight: 500;
      word-break: break-all;
    }

    .showTypes {
      .empty-div {
        height: 16px;
        background: #f5f5f5;
      }

      .cards {
        display: flex;
        align-items: center;
        height: 120px;
        line-height: 120px;
        // background: pink;
        padding: 0 0 0 32px;

        .imges {
          display: flex;
          align-items: center;
          // width: 200px;
          .imgselect {
            width: 48px;
            height: 48px;
            vertical-align: middle;
          }

          .avatras {
            width: 74px;
            height: 74px;
            border-radius: 8px;
            margin-left: 36px;
          }
        }
        img {
          width: 74px;
          height: 74px;
          border-radius: 8px;
        }
        .rightes {
          width: 100%;
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-left: 32px;
          border-bottom: 1px solid #e4e5e6;
          .applicationNames {
            font-size: 36px;
            font-weight: 500;
            color: #333333;
          }
          .imgs {
            width: 40px;
            height: 40px;
            margin-right: 20px;
          }
        }
      }
    }

    .showUsers {
      .cards {
        display: flex;
        align-items: center;
        height: 120px;
        line-height: 120px;
        // background: pink;
        padding: 0 0 0 32px;

        .imges {
          display: flex;
          align-items: center;
          width: 200px;
          .imgselect {
            width: 48px;
            height: 48px;
          }

          .avatras {
            width: 74px;
            height: 74px;
            border-radius: 8px;
            margin-left: 36px;
          }
        }

        .rights {
          width: 100%;
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-left: 32px;
          border-bottom: 1px solid #e4e5e6;
          padding-right: 40px;
          .applicationNames {
            font-size: 36px;
            font-weight: 500;
            color: #333333;
          }
          .idNumbers {
            color: #666;
          }
        }
      }
    }
  }

  .subBtn {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 118px;
    background: #f4f8fb;
    div {
      width: 192px;
      height: 80px;
      line-height: 80px;
      text-align: center;
      background: #1365dd;
      border-radius: 4px;
      font-size: 32px;
      color: #fff;
      margin: 20px 34px 0 0;
      float: right;
    }
  }
}
</style>
